//SpaceProject TENKOUSEI OFM Archive
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

unsigned char	fileheader[4] = { 'S', 'U', 'N', 'D' };

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	char				tmp[0x20];
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				header_filename_top[12];
	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	unsigned long		nowsize = 0L;

	unsigned int		i = 0;

	memset( header_filename_top, 0, sizeof( header_filename_top ));

	printf( "SpaceProject OFM Divider 060224 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: OFMDIV <filename>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	fread( tmp, 0x10, 1, in );
	if( memcmp( &tmp[8], fileheader, 4 ))
	{
		printf( "error: not OFM format.\n" );
		goto end;
	}

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "file_size: %lu bytes\n", file_ed );
	printf( "\n" );

	memcpy( header_filename_top, av[1], strlen( av[1] ) - 4 );

	fseek( in, 0x10, SEEK_SET );

	while( file_ed > ftell( in ))
	{
		fread( tmp, 0x1C, 1, in );
		if( memcmp( tmp, "FOBJ", 4 ))
		{
			fseek( in, -0x1B, SEEK_CUR );
			continue;
		}

		i++;
		sprintf( header_filename, "%s_%02d.BIN", header_filename_top, i );
		header_filesize = *( unsigned int *)( tmp + 0x1A );

		printf( "%03d %-13s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			ftell( in ),
			ftell( in ) + header_filesize,
			header_filesize
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, 32768 );	//32k
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );
		printf( ".\n" );
		fclose( out );

		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	fclose( in );
	return;
}
